--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Blues Evaluation component
--
-- Author  Matthew Caryl
-- Created 3.2.97
--

with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation.Bit_Vector;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation.Bit_Vector;

package body Blues_Evaluation is

	function Evaluate(Evaluation : in Blues_Evaluation; Representation : in Representation_Access) return Float is
		r : Integer  := 0;
		b : Bit_Representation_Access;
		v : Vector_Representation_Access := Vector_Representation_Access(Representation);
	begin
		Get(v, 1, b);
		if Get(b) then
			Get(v, 2, b);
			if Get(b) then
				return 10.0;
			else
				return 1.0;
			end if;
		else
			Get(v, 2, b);
			if Get(b) then
				return 2.0;
			else
				return 5.0;
			end if;
		end if;
	end Evaluate;

end Blues_Evaluation;
