--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Blues Evaluation component
--
-- Author  Matthew Caryl
-- Created 3.2.97
--

with Mutants.Core.Evaluation;
with Mutants.Core.Representation;

use Mutants.Core.Evaluation;
use Mutants.Core.Representation;

package Blues_Evaluation is

	type Blues_Evaluation is new Mutants.Core.Evaluation.Evaluation with private;

	function Evaluate(Evaluation : in Blues_Evaluation; Representation : in Representation_Access) return Float;

private

	type Blues_Evaluation is new Mutants.Core.Evaluation.Evaluation with null record;

end Blues_Evaluation;
