--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Xor creator component
--
-- Author  Matthew Caryl
-- Created 15.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Random;
use Mutants.Core.Selector;
use Mutants.Core.Random;

package Mutants.Core.Creator.Bxor is

	type Xor_Creator(One : Creator_Access; WeightOne : Natural; Two : Creator_Access; WeightTwo : Natural; Random : Random_Access) is new Creator with private;

	procedure Create(Creator : in out Xor_Creator; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Xor_Creator; Sel : Selector_Access; Required : out Boolean);
	
private
	
	type Xor_Creator(One : Creator_Access; WeightOne : Natural; Two : Creator_Access; WeightTwo : Natural; Random : Random_Access) is new Creator with
		record
			Left : Creator_Access := One;
			LeftWeight : Natural := WeightOne;
			Right : Creator_Access := Two;
			RightWeight : Natural := WeightTwo;
			Chance : Random_Access := Random;
		end record;
	
	function Parents(Creator : in Xor_Creator) return Natural;
	procedure Breed(Creator : in out Xor_Creator; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Core.Creator.Bxor;
