--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Ending component
--
-- Author  Matthew Caryl
-- Created 12.12.96
--

package body Mutants.Core.Ending.Count is

	-- Error if they keep calling ending after it starts reporting false
	procedure Done(Ending : in out Count_Ending; Done : out Boolean) is
	begin
		if Ending.Count = 0 then
			Done := true;
		else
			Ending.Count := Ending.Count - 1;
			Done := false;
		end if;
	end Done;

	procedure Reset(Ending : in out Count_Ending; Count : Integer) is
	begin
		Ending.Count := Count;
	end Reset;

end Mutants.Core.Ending.Count;
