--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Representation component
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

package Mutants.Core.Representation is

	type Representation is abstract tagged private;
	type Representation_Access is access all Representation'Class;
        type Representation_Access_Array is array(Integer range <>) of
 Representation_Access;
 
 	function Equal(one, two : Representation) return Boolean is abstract;
 
private

	type Representation is tagged null record;

end Mutants.Core.Representation;
