--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Extended toolkit - Integer order initialise component
--
-- Author  Matthew Caryl
-- Created 5.2.96
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Creator;
with Mutants.Extended.Representation.Integer_Order;
use Mutants.Core.Selector;
use Mutants.Core.Representation;
use Mutants.Extended.Representation.Integer_Order;

package Mutants.Extended.Creator.Integer_Order_Initialise is
	
	type Integer_Order_Initialise(Size : Natural) is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Integer_Order_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Integer_Order_Initialise; Sel : Selector_Access; Required : out Boolean);

private
	
	type Integer_Order_Initialise(Size : Natural) is new Mutants.Core.Creator.Creator with
		record
			Maximum : Natural := Size;
		end record;
	
	function Parents(Creator : in Integer_Order_Initialise) return Natural;
	procedure Breed(Creator : in out Integer_Order_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);
	
end Mutants.Extended.Creator.Integer_Order_Initialise;
