--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Bit mutation reproduction component
--
-- Author  Matthew Caryl
-- Created 15.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Individual;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Selector;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Individual;
use Mutants.Core.Population;

package body Mutants.Core.Creator.Bit_Mutation_Reproduction is

	procedure Free is new Ada.Unchecked_Deallocation(Bit_Representation, Bit_Representation_Access);

	procedure Create(Creator : in out Bit_Mutation_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		r : Representation_Access;
		b : Bit_Representation_Access;
	begin
		b := new Bit_Representation;
		for j in 1..Size loop
			Get(Creator.Selector.all, i);
			r := Mutants.Core.Individual.Representation(i);
			if Get(Bit_Representation_Access(b)) then
				Set(b, false);
			else
				Set(b, true);
			end if;
			i := new Mutants.Core.Individual.Individual(Representation_Access(b));
			Add(Pop, i);
		end loop;
		Free(b);
	end Create;
	
	procedure Selector(Creator : in out Bit_Mutation_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin
		Creator.Selector := Sel;
		Required := true;
	end Selector;
			
	function Parents(Creator : in Bit_Mutation_Reproduction) return Natural is
	begin
		return 1;
	end Parents;

	procedure Breed(Creator : in out Bit_Mutation_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		r : Representation_Access;
		b : Bit_Representation_Access;
	begin
		b := new Bit_Representation;
		if Get(Bit_Representation_Access(Reps_In(1))) then
			Set(b, false);
		else
			Set(b, true);
		end if;
		Rep_Out := Representation_Access(b);
		Success := true;
	end Breed;

end Mutants.Core.Creator.Bit_Mutation_Reproduction;
