--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Bit mutation reproduction component
--
-- Author  Matthew Caryl
-- Created 15.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation;
use Mutants.Core.Selector;
use Mutants.Core.Representation;

package Mutants.Core.Creator.Bit_Mutation_Reproduction is

	type Bit_Mutation_Reproduction is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Bit_Mutation_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Bit_Mutation_Reproduction; Sel : Selector_Access; Required : out Boolean);
	
private
	
	type Bit_Mutation_Reproduction is new Mutants.Core.Creator.Creator with
		record
			Selector : Selector_Access;
		end record;
			
	function Parents(Creator : in Bit_Mutation_Reproduction) return Natural;
	procedure Breed(Creator : in out Bit_Mutation_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Core.Creator.Bit_Mutation_Reproduction;
