--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Clone reproduction component
--
-- Author  Matthew Caryl
-- Created 15.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation;
with Mutants.Core.Individual;
use Mutants.Core.Selector;
use Mutants.Core.Representation;
use Mutants.Core.Population;
use Mutants.Core.Individual;

package body Mutants.Core.Creator.Clone_Reproduction is

	procedure Create(Creator : in out Clone_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		r : Representation_Access;
	begin
		for k in 1..Size loop
			Get(Creator.Selector.all, i);
			r := Mutants.Core.Individual.Representation(i);
			i := new Mutants.Core.Individual.Individual(r);
			Add(Pop, i);
		end loop;
	end Create;

	procedure Selector(Creator : in out Clone_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin
		Creator.Selector := Sel;
		Required := true;
	end Selector;

	function Parents(Creator : in Clone_Reproduction) return Natural is
	begin
		return 1;
	end Parents;

	procedure Breed(Creator : in out Clone_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
	begin
		Rep_Out := new Mutants.Core.Representation.Representation'Class'(Reps_In(1).all);
		Success := true;
	end Breed;

end Mutants.Core.Creator.Clone_Reproduction;
