--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Clone reproduction component
--
-- Author  Matthew Caryl
-- Created 15.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation;
use Mutants.Core.Selector;
use Mutants.Core.Representation;

package Mutants.Core.Creator.Clone_Reproduction is

	type Clone_Reproduction is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Clone_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Clone_Reproduction; Sel : Selector_Access; Required : out Boolean);
	
private
	
	type Clone_Reproduction is new Mutants.Core.Creator.Creator with
		record
			Selector : Selector_Access;
		end record;
	
	function Parents(Creator : in Clone_Reproduction) return Natural;
	procedure Breed(Creator : in out Clone_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Core.Creator.Clone_Reproduction;
