--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - One point vector crossover reproduction component
--
-- Author  Matthew Caryl
-- Created 22.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Vector;
with Mutants.Core.Random;
use Mutants.Core.Selector;
use Mutants.Core.Population;
use Mutants.Core.Random;

generic
	with package Vector_Package is new Mutants.Core.Representation.Vector(<>);

package Mutants.Core.Creator.Onepoint_Vector_Crossover_Reproduction is

	type Onepoint_Vector_Crossover_Reproduction(Random : Random_Access) is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Onepoint_Vector_Crossover_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Onepoint_Vector_Crossover_Reproduction; Sel : Selector_Access; Required : out Boolean);
	
private
	
	type Onepoint_Vector_Crossover_Reproduction(Random : Random_Access) is new Mutants.Core.Creator.Creator with
		record
			Selector : Selector_Access;
			Chance : Random_Access := Random;
		end record;
			
	function Parents(Creator : in Onepoint_Vector_Crossover_Reproduction) return Natural;
	procedure Breed(Creator : in out Onepoint_Vector_Crossover_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Core.Creator.Onepoint_Vector_Crossover_Reproduction;
