--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Count Ending component
--
-- Author  Matthew Caryl
-- Created 10.12.96
--

with Mutants.Core.Ending;

package Mutants.Core.Ending.Count is

	type Count_Ending is new Ending with private;

	procedure Done(Ending : in out Count_Ending; Done : out Boolean);
	procedure Reset(Ending : in out Count_Ending; Count : Integer);

private
	
	type Count_Ending is new Ending with
		record
			Count : Natural := 0;
		end record;

end Mutants.Core.Ending.Count;
