--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Ending component
--
-- Author  Matthew Caryl
-- Created 10.12.96
--

with Ada.Calendar;

package Mutants.Core.Ending is

	type Ending is abstract tagged private;
	subtype Ending_Class is Ending'Class;

	procedure Done(Ending : in out Ending; Done : out Boolean) is abstract;

private
	
	type Ending is abstract tagged null record;
	
end Mutants.Core.Ending;
