--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - High Selector component
--
-- Author  Matthew Caryl
-- Created 19.12.96
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
use Mutants.Core.Selector;
use Mutants.Core.Individual;

package Mutants.Core.Selector.High is

        type High_Selector is new Selector with private;

        procedure Attach(Sel : in out High_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class);
        procedure Get(Sel : in out High_Selector; Individual : out Individual_Access);
        procedure Put(Sel : in out High_Selector; Individual : in Individual_Access);

private

        type High_Selector is new Selector with
		record
			High_Individual : Individual_Access := null; 
		end record;

end Mutants.Core.Selector.High;
